;
;	>>> Silly Things by JAC! <<<
;
;	Created 2010-10-10/2010-12-09 for the Sillyventure 2010 in Gdansk.
;	This is the "Silly Things Header" generator for the intro and the main part.
;	Save using "write 3000 327B C:\jac\system\Atari800\Programming\Demos\SillyThings\header\Silly-Header.dat"
;	Save using "write 4000 4346 C:\jac\system\Atari800\Programming\Demos\SillyThings\header\Silly-Header.bin"
;	Always write both file to prevent inconsistencies.

; def intro_mode

; Constants
pixels_set	= 212			;$d4
pixels_split1	= 54			;Number of pixels for the first RTS
pixels_split2	= 104			;Number of pixels for the second RTS
pixels_split3	= 156			;Number of pixels for the third RTS

; Zero Page
header_map1	= header_zp		;32 bytes, $00, $10, $20, ... $f0, $e0, ...$00
header_map2	= header_map1+$20	;32 bytes, $00, $01, $02, ... $0f, $0e, ...$00

; Main Memory
data_start	= $3000
routine_start	= $4000

;===============================================================

	opt l+

	org $2000

	icl "../Silly-Globals.asm"	;defines header_zp and header_sm
	icl "../Silly-Kernel-Equates.asm"
	icl "../Silly-Kernel.asm"

;===============================================================

	.proc main
start	jsr init
	jsr generate
	
	jsr sync.vcount
	mva #$22 dmactl
	mwa #dl dlptr
	mva #$50 prior		;Graphics 9 plus 5th player
	mva #0 colbk

	mva #$30 colpf3		;5th player color
	mva #$30 hposm0		;Inital missle positions
	mva #$36 hposm1
	mva #$7a hposm2
	mva #$82 hposm3		;This one wil lbe changed by the DLI
	mva #$ff sizem		;Maximum width

	jsr effect.init_colors

loop	jsr sync.vcount

	ldx #0
sync	lda vcounttab,x
	cmp vcount
	bne sync
	lda grafmtab,x
	sta grafm
	lda hposm3tab,x
	sta hposm3
	inx
	cpx #6
	bne sync

	lda #50
	cmp vcount
	bne *-5

	lda #14
	sta colbk
	jsr effect.move
	lda $d20f
	and #12
	cmp #12
	beq no_key

	lda effect.move.move_cnt
	bne no_key
	lda effect.map_fade
	bmi no_key
	jsr effect.fade_down
	dec effect.map_fade
no_key
	lda #0
	sta colbk
	
	inc cnt
	lda #0
	sta colbk
	
	jmp loop

vcounttab	.byte 16,18,20,22,24,26
grafmtab	.byte $ff,$82,$8f,$84,$8f,$00
hposm3tab	.byte $82,$80,$80,$80,$80,$80


dl	.byte $70,$70,$70
	.rept 5
	.byte $4f
	.word header_sm+#*40
	.byte $4f
	.word header_sm+#*40
	.byte $4f
	.word header_sm+#*40
	.byte $4f
	.word header_sm+#*40
	.endr
	.byte $41
	.word dl

;===============================================================
	.proc init
	sei
	lda vcount
	bne *-3
	sta nmien
	sta irqen
	lda #$ff
	sta portb

	jsr effect.init
	rts
	.endp
	
;===============================================================
	.proc generate	
; Variables
	.var xpos		.byte
	.var ypos		.byte
	.var pixel1		.byte
	.var pixel2		.byte
	.var pixel_count	.byte
	.var pixel_index	.word
	.var last_store_adr = [routine+routine.routine1+1]	.word 

	mwa #routine+routine.routine1 poke.poke_adr
	mva #0 pixel_index

	mva #0 ypos
loopy
	mva #0 xpos
	
loopx	jsr get_pixel
	sta pixel1
	inc xpos

	jsr get_pixel
	sta pixel2
	inc xpos

	jsr store_pixel
	
	
	lda xpos
	cmp #80
	bne loopx

	inc ypos
	lda ypos
	cmp #5
	bne loopy

	jmp poke.poke_rts

;===============================================================

	.proc get_pixel
	
	.var temp .byte
	
	lda ypos
	asl
	sta temp
	asl
	asl
	ora temp
	sta temp

	lda xpos
	lsr
	lsr
	lsr
	clc
	adc temp
	tax
	lda xpos
	and #7
	tay
	lda input.picture,x
	and bitmask,y
	beq zero
	lda #1
zero	rts

bitmask	.byte $80,$40,$20,$10,$08,$04,$02,$01
	.endp

;===============================================================

	.proc store_pixel
	lda pixel1
	clc
	adc pixel2
	beq no_pixel

	cmp #2
	beq two_pixels
	lda pixel1
	bne one_pixel1
	beq one_pixel2

one_pixel1
	lda #$a5
	jsr poke.poke_a
	lda #header_map1
	jsr store_adr
	inw pixel_index
	inw pixel_index
	jmp poke_sta

one_pixel2
	inw pixel_index
	lda #$a5
	jsr poke.poke_a
	lda #header_map2
	jsr store_adr
	inw pixel_index
	jmp poke_sta
	
two_pixels
	lda #$a5	;lda zp
	jsr poke.poke_a
	lda #header_map1
	jsr store_adr
	inw pixel_index
	lda #$05	;ora zp
	jsr poke.poke_a
	lda #header_map2
	jsr store_adr
	inw pixel_index
	jmp poke_sta

no_pixel
	inw pixel_index
	inw pixel_index
	rts


poke_sta
	lda #$8d
	jsr poke.poke_a
	lda pixel_index+1
	lsr
	lda pixel_index
	ror
	sec
	sbc #1
	jsr poke.poke_a
	lda #>header_sm
	jsr poke.poke_a

	lda pixel_count		;Split routine using RTS?
	cmp #pixels_split1
	beq do_split
	cmp #pixels_split2
	beq do_split
	cmp #pixels_split3
	bne no_split
do_split
	jsr poke.poke_rts
no_split
	rts

;===============================================================
	.proc store_adr
	
	.var offset_adr .word
	
	pha
	jsr poke.poke_a	;header_map1 or header_map2
	
	sbw poke.poke_adr last_store_adr offset_adr

	ldx pixel_count
	lda offset_adr
	sta data.header_adradd,x

	mwa poke.poke_adr last_store_adr

	pla
	sta data.header_map,x

	adw pixel_index #input.color_original color_adr

	lda input.color_original
color_adr = *-2
	sta data.header_color,x

	inc pixel_count
	beq error
	rts

error	lda #$34
	sta $d01a
	jmp *
	.endp	;End of store_adr

	.endp	;End of store_pixel

	.endp	;End of generate
;===============================================================

	icl "Silly-Header.asm"

	.endp	;End of main
;===============================================================
; Input
	.local input

; 50 bytes picture	
picture	ins "Silly-Header.pic"

; 400 bytes color values 0..31
color_original
;	.byte 10,9,8,7,7,6,5,4,3,2,1,0,31,30,30,29,28,27,26,25,25,24,23,22,21,21,20,19,19,18,18,17,17,16,16,15,15,15,15,15,15,15,15,15,15,15,16,16,17,17,18,18,19,19,20,21,21,22,23,24,25,25,26,27,28,29,30,30,31,0,1,2,3,4,5,6,7,7,8,9,9,8,7,6,5,5,4,3,2,1,0,31,30,29,28,27,26,25,25,24,23,22,21,20,20,19,18,17,16,16,15,15,14,13,13,13,12,12,12,12,12,12,12,12,12,13,13,13,14,15,15,16,16,17,18,19,20,20,21,22,23,24,25,25,26,27,28,29,30,31,0,1,2,3,4,5,5,6,7,8,9,8,7,6,5,4,3,2,1,0,31,30,29,28,27,26,25,24,23,22,21,21,20,19,18,17,16,15,15,14,13,12,12,11,10,10,9,9,9,9,9,9,9,9,9,10,10,11,12,12,13,14,15,15,16,17,18,19,20,21,21,22,23,24,25,26,27,28,29,30,31,0,1,2,3,4,5,6,7,8,8,7,6,5,4,3,2,1,0,31,30,29,28,27,26,25,24,23,22,21,20,19,18,18,17,16,15,14,13,12,11,10,10,9,8,7,7,6,6,6,6,6,6,6,7,7,8,9,10,10,11,12,13,14,15,16,17,18,18,19,20,21,22,23,24,25,26,27,28,29,30,31,0,1,2,3,4,5,6,7,8,7,6,5,4,3,2,1,0,31,30,29,28,27,26,25,24,23,22,21,20,19,18,17,16,15,14,13,12,11,10,9,8,7,6,5,5,4,3,3,3,3,3,4,5,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,0,1,2,3,4,5,6,7
	.byte 29,28,26,25,24,22,21,19,18,16,15,14,12,11,9,8,7,5,4,2,1,0,30,29,28,27,25,24,23,22,21,20,19,18,17,16,16,15,15,15,15,15,15,15,16,16,17,18,19,20,21,22,23,24,25,27,28,29,30,0,1,2,4,5,7,8,9,11,12,14,15,16,18,19,21,22,24,25,26,28,29,27,26,24,23,21,20,18,17,16,14,13,11,10,8,7,5,4,3,1,0,30,29,28,26,25,24,22,21,20,19,18,16,15,15,14,13,12,12,12,12,12,12,12,13,14,15,15,16,18,19,20,21,22,24,25,26,28,29,30,0,1,3,4,5,7,8,10,11,13,14,16,17,18,20,21,23,24,26,27,28,27,25,24,22,21,19,18,16,15,13,12,10,9,8,6,5,3,2,0,31,29,28,27,25,24,22,21,20,18,17,16,15,13,12,11,10,10,9,9,9,9,9,10,10,11,12,13,15,16,17,18,20,21,22,24,25,27,28,29,31,0,2,3,5,6,8,9,10,12,13,15,16,18,19,21,22,24,25,27,28,26,25,23,22,20,19,17,16,14,13,11,10,8,7,5,4,3,1,0,30,29,27,26,24,23,21,20,18,17,16,14,13,12,10,9,8,7,6,6,6,6,6,7,8,9,10,12,13,14,16,17,18,20,21,23,24,26,27,29,30,0,1,3,4,5,7,8,10,11,13,14,16,17,19,20,22,23,25,26,28,26,25,23,22,20,19,17,16,14,13,11,10,8,7,5,4,2,1,31,30,28,27,25,24,22,21,19,18,16,15,13,12,10,9,8,6,5,4,3,3,3,4,5,6,8,9,10,12,13,15,16,18,19,21,22,24,25,27,28,30,31,1,2,4,5,7,8,10,11,13,14,16,17,19,20,22,23,25,26
color_original_end
	.endl

;===============================================================
; Output

	org data_start

	.local data
header_adradd	.ds pixels_set			;Condensed layout
header_map	.ds pixels_set			;Condensed layout
header_color	.ds pixels_set			;Condensed layout
	.endl

	org routine_start

	.local routine
routine1	= $000	;The offsets a taken from the monitor
routine2	= $0d3
routine3	= $1a1
routine4	= $273
routine_end	= $4345
	.endl

	run main.start

;===============================================================
	.print "Pixel Count    : ", main.generate.pixel_count
	.print "Data (.dat)    : ", data, " - ", data + .len data -1, " (", .len data,")"
	.print "Color          : ", input.color_original, " - ", input.color_original_end -1, " (", input.color_original_end-input.color_original,")"
	.print "Routine (.bin) : ", routine_start, " - "
