;
;	>>> Silly Things by JAC! <<<
;
;	Created 2010-10-10/2010-12-09 for the Sillyventure 2010 in Gdansk.
;
;	This is the test from for determining the timing of the splits.

p1	= $90
p2	= $92

splittab	= $0400
chrtab		= $0500
chract		= $20	;ZP

chr_empty	= $3000
chr_end		= $10000
chr_size	= $400
picture_size	= $140

generated_splits = $3a00

char_width	= 40
char_height	= 24
char_splits	= 32
lines_height	= char_height*8
lines_height2	= char_height*8+2*8	;inlcuding the leading and trailing line

dmactl = $d400
dlptr  = $d402
vscrol = $d405
chbase = $d409
wsync  = $d40a
vcount = $d40b
hitclr = $d01e

	opt l+

	org $1400

	.macro clear_memory
	.if (:1 & $ff == 0) && (:2 & $ff == 0)
	lda #>:1
	ldx #>:2
	jsr clear.clear_page_ax
	.else
	.error "Clear page not even ", :1, " ", :2
	.endif
	.endm

start	jsr init

	lda #0
	sta $d01a
	
	lda #$ff
	sta $d00d
	lda #8
	sta $d012
	lda #1
	sta $d01b

loop	jsr kernel
	jmp loop
	
	sty $d000
	sta $d000,x

;===============================================================

	.proc init
	lda $d40b
	bne *-3
	sei
	sta $d40e
	sta dmactl
	sta $d20e
	lda #$fe
	sta $d301

	clc
	lda #$34
	sta $d016
	adc #4
	sta $d017
	adc #4
	sta $d018

	ldx #char_width-1
fill_sm	txa
	sta sm,x
	sta sm+char_width,x
	dex
	bpl fill_sm

	mwa #pictures_end-picture_size p1
	mwa #chr_end-chr_size p2
	jsr copy_pictures

	clear_memory chr_empty $800

	ldx #7
	lda #>chr_empty
set_chr_empty
	sta chract,x
	sta chract+8+lines_height,x
	dex
	bpl set_chr_empty

init_chract
	lda $d010
	asl
	asl
	sta x1
	
	ldx #0
init_chract1
	lda chrtab,x
	ora x1
	sta chract+8,x
	inx
	cpx #lines_height
	bne init_chract1
	
	ldx #0
	ldy #>generated_splits
init_splits
	tya
	sta splittab,x		;Free pages 2 each charset is reserved for split routines
	iny
	inx
	tya
	sta splittab,x		;Free pages 3 each charset is reserved for split routines
	iny
	inx
	iny			;Page 1 is reserved for charset
	iny			;Page 2 is reserved for charset
	cpx #char_splits+1
	bcc init_splits

	jsr generate
	rts

x1	.byte 0

	.endp

;===============================================================

	.proc clear
clear_page_ax
	sta clear_page_ax_adr+2
	lda #0
	tay
clear_page_ax_adr
	sta $ff00,y
	iny
	bne clear_page_ax_adr
	inc clear_page_ax_adr+2
	dex
	bne clear_page_ax_adr
	rts
	.endp

;===============================================================
	.proc copy_pictures
	ldx #char_height-1
copy_line
	jsr copy_chr

	txa
	asl
	asl
	asl
	tay
	lda p2+1
:8	sta chrtab,y+

	jsr copy_chr

	dex
	bpl copy_line
	rts

copy_chr
	ldy #0
copy_chr1
	lda (p1),y
	sta (p2),y
	iny
	bne copy_chr1
	inc p1+1
	inc p2+1
	ldy #$3f
copy_chr2
	lda (p1),y
	sta (p2),y
	dey
	bpl copy_chr2
	
	sbw p1 #$100+picture_size
	sec
	lda p2+1
	sbc #1+>chr_size

	cmp #$d8		;Skip $d00-$d7ff
	bcs noskip
	cmp #$d0
	bcc noskip
	sec
	sbc #($d8-$d0)
noskip	sta p2+1
	rts
	.endp

;===============================================================

	.proc generate

	jsr generate_lines
	jsr generate_splits

	rts

;===============================================================

generate_lines
	mwa #generated_kernel poke+1
	mva #0 line_count

	jsr normal_lines

	mva #char_height+1 char_count
generate_lines_loop
	jsr full_line
	dec char_count
	bne generate_lines_loop

	lda #$60	;RTS
	jmp poke

;	
full_line
	jsr bad_line

normal_lines
	jsr normal_line
	jsr normal_line
	jsr normal_line
	jsr normal_line
	jsr normal_line
	jsr normal_line
	jmp normal_line

bad_line
	inc bad_line_count
	lda #$8e	;stx vscrol
	ldx #<vscrol
	ldy #>vscrol
	jsr poke_axy
	jmp split_line

normal_line
	lda bad_line_count
	and #1
	asl
	asl
	asl
	eor #$0c
	jsr ldx_a2
	lda line_count
	lsr
	tax
	lda pmhpos,x
	clc
	adc #1
	jsr ldy_a0
	jmp split_line

pmhpos	.byte 0,0,0,0
	.byte $30,$34,$38,$3c,$44,$4c,$54,$5c,$64,$6c,$74,$7c,$84,$88
	.byte $8c,$90,$94,$98,$9c,$a0,$a4,$a8,$ac,$b0,$b4,$b8,$bc,$c0,$c4,$c8,$c8,$d0
:256	.byte 0

split_reg = chbase
;split_reg = $d01a

split_line
;	ldx line_count
;	lda chract+1,x
;	jsr lda_a9

	ldx #$a5	;lda chract+1+line_count (zp)
	lda line_count
	sec
	adc #chract
	tay
	jsr poke_xy

	jsr sta_split_reg

	ldx #$49	;eor #$04
	ldy #$04
	jsr poke_xy

	lda #$8c	;sty $d000
	ldx #$00
	ldy #$d0
	jsr poke_axy

	ldx #$20	;jsr $xx00
	ldy #$00
	jsr poke_xy

	lda line_count
	sec
	sbc #6
	bcc split_line0
	lsr
	tax
	cpx #char_splits+1
	bcc split_line1
split_line0
	ldx #0
split_line1
	lda splittab,x
	jsr poke

	inc line_count
	rts

sta_split_reg
	lda #$8d	;sta split_reg
	ldx #<split_reg
	ldy #>split_reg
	jmp poke_axy

char_count	.ds 1
line_count	.ds 1
bad_line_count	.ds 1

;===============================================================
;	Generate split subroutines
generate_splits
	mva #char_splits split_count
generate_splits_loop
	ldx split_count
	mva #0 poke+1
	lda splittab,x
	sta poke+2
	jsr generate_split
	dec split_count
	bpl generate_splits_loop
	rts

generate_split
	lda split_count
	and #1
	bne generate_split_odd

generate_split_even
	lda split_count
	lsr
	tax
	jsr nops
	jsr sta_split_reg
	sec
	lda #char_splits+1
	sbc split_count
	lsr
	tax
	jsr nops
	lda #$60
	jmp poke


generate_split_odd
	lda split_count
	cmp #3
	bcc generate_split_even
	lda split_count
	cmp #char_splits-1
	bcs generate_split_even

	lsr
	tax
	dex	;one less NOP
	jsr nops

	jsr bit_zp
	jsr sta_split_reg
	jsr bit_zp

	sec
	lda #char_splits+1
	sbc split_count
	lsr
	tax
	dex	;one less NOP
	dex	;one less NOP	
	jsr nops
	lda #$60
	jmp poke

split_count	.ds 1

bit_zp	ldx #$24	;bit $nn
	ldy #$00
	jmp poke_xy

;===============================================================
;	General purpose code routines
nops	cpx #0
	beq nonops
	lda #$ea
	jsr poke
	dex
	bne nops
nonops	rts

lda_a9
	pha
	lda #$a9
	bne pla_poke
ldx_a2
	pha
	lda #$a2
	bne pla_poke
ldy_a0
	pha
	lda #$a0
	bne pla_poke

poke_axy
	jsr poke
poke_xy
	txa
	jsr poke
	tya
	jmp poke

pla_poke
	jsr poke
	pla
poke	sta $ffff
	sta $d01a
	inw poke+1
	rts

	.endp

;===============================================================

	.proc kernel
loop
wait_loop
	lda vcount		;Synchronization for the first screen line
	cmp #$02
	bne wait_loop
:3	sta wsync

;	Wait 36 cycles
	jsr wait6cycles
	jsr wait6cycles
	mva #%00100010 dmactl	;Set new screen width
	mva #<dl dlptr
	mva #>dl dlptr+1

;	Set global offset (7 cycles)
	pha:pla		;3+4 = 7 cycles

;line0
	jsr wait24cycles
	pha:pla		;3+4 = 7 cycles
	ldx #$04	;2 cycles
	ldy #$0c	;2 cycles
	stx vscrol
	nop
	lda $00
	nop
	lda $00
	jsr generated_kernel

	lda #0
	sta $d01a
	sta dmactl
	rts

wait24cycles
	jsr wait6cycles
wait6cycles
	rts

byt3	.byte 0
	.endp

;===============================================================
	.align 1024

dc	= $04
dl	.byte $40+$20+dc
	.word sm
	.byte dc
	.rept 14
	.byte $20+dc,dc
	.endr

	.byte $41
	.word dl

sm	.ds char_width*2

generated_kernel

pictures
;	ins "Silly-Split-Pictures.dat"
	ins "Silly-Split-Test-Pictures-A.dat"
;	ins "Silly-Split-Test-Pictures-B.dat"
;	ins "Silly-Split-Test-Pictures-C.dat"
;	ins "Silly-Split-Test-Frame.dat"
pictures_end

	run start
